<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/TypeAnalysis/Type.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/TypeAnalysis/Type.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/TypeAnalysis/Type.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2005 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_TypeAnalysis_Type_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_TypeAnalysis_Type_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;Synopsis/TypeAnalysis/Visitor.hh&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;string&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">#include &lt;ostream&gt;</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">#include &lt;iterator&gt;</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">{</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/TypeAnalysis.html" title="namespace Synopsis::TypeAnalysis">TypeAnalysis</a></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">{</span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">{</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::Type::Type(const std::string&amp;)">Type</a>(<a href="" title="typedef std::string">std::string const</a> &amp;name) : my_name(name), my_refcounter(1) {}</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#_tType_l_r" title="member function Synopsis::TypeAnalysis::Type::~Type()">~Type</a>() {}</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">  <span class="keyword">const</span> <a href="" title="typedef std::string">std::string</a> &amp;<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#name_l_rconst" title="member function Synopsis::TypeAnalysis::Type::name()const">name</a>() const { <span class="keyword">return</span> my_name;}</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Type::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) = 0;</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#ref_l_rconst" title="member function Synopsis::TypeAnalysis::Type::ref()const">ref</a>() const { ++<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#my_refcounter" title="data member Synopsis::TypeAnalysis::Type::my_refcounter">my_refcounter</a>;}</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#deref_l_rconst" title="member function Synopsis::TypeAnalysis::Type::deref()const">deref</a>() const { <span class="keyword">if</span> (--<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#my_refcounter" title="data member Synopsis::TypeAnalysis::Type::my_refcounter">my_refcounter</a>) <span class="keyword">delete</span> <span class="keyword">this</span>;}</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">  <span class="comment">// TODO: add 'new' / 'delete' operators for optimization.</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">  <span class="keyword">const</span> <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#my_name" title="data member Synopsis::TypeAnalysis::Type::my_name">my_name</a>;</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">  mutable <a href="" title="typedef size_t">size_t</a>    <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html#my_refcounter" title="data member Synopsis::TypeAnalysis::Type::my_refcounter">my_refcounter</a>;</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">};</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">{</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::BuiltinType::BuiltinType(const std::string&amp;)">BuiltinType</a>(<a href="" title="typedef std::string">std::string const</a> &amp;name) : Type(name) {}</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::BuiltinType::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">  <span class="comment">// BuiltinType is preallocated and thus is destructed at program termination.</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html#ref_l_rconst" title="member function Synopsis::TypeAnalysis::BuiltinType::ref()const">ref</a>() const {}</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html#deref_l_rconst" title="member function Synopsis::TypeAnalysis::BuiltinType::deref()const">deref</a>() const {}</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">};</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#BOOL" title="namespace variable Synopsis::TypeAnalysis::BOOL">BOOL</a>;</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#CHAR" title="namespace variable Synopsis::TypeAnalysis::CHAR">CHAR</a>;</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#WCHAR" title="namespace variable Synopsis::TypeAnalysis::WCHAR">WCHAR</a>;</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#SHORT" title="namespace variable Synopsis::TypeAnalysis::SHORT">SHORT</a>;</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#INT" title="namespace variable Synopsis::TypeAnalysis::INT">INT</a>;</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#LONG" title="namespace variable Synopsis::TypeAnalysis::LONG">LONG</a>;</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#FLOAT" title="namespace variable Synopsis::TypeAnalysis::FLOAT">FLOAT</a>;</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#DOUBLE" title="namespace variable Synopsis::TypeAnalysis::DOUBLE">DOUBLE</a>;</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#UCHAR" title="namespace variable Synopsis::TypeAnalysis::UCHAR">UCHAR</a>;</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#USHORT" title="namespace variable Synopsis::TypeAnalysis::USHORT">USHORT</a>;</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#UINT" title="namespace variable Synopsis::TypeAnalysis::UINT">UINT</a>;</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#ULONG" title="namespace variable Synopsis::TypeAnalysis::ULONG">ULONG</a>;</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#SCHAR" title="namespace variable Synopsis::TypeAnalysis::SCHAR">SCHAR</a>;</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#SSHORT" title="namespace variable Synopsis::TypeAnalysis::SSHORT">SSHORT</a>;</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#SINT" title="namespace variable Synopsis::TypeAnalysis::SINT">SINT</a>;</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">extern <a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> <a href="../../../Scopes/Synopsis/TypeAnalysis.html#SLONG" title="namespace variable Synopsis::TypeAnalysis::SLONG">SLONG</a>;</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Enum.html" title="class Synopsis::TypeAnalysis::Enum">Enum</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">{</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::Enum::Enum(const std::string&amp;)">Enum</a>(<a href="" title="typedef std::string">std::string const</a> &amp;name) : Type(name) {}</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Enum.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Enum::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">};</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Compound.html" title="class Synopsis::TypeAnalysis::Compound">Compound</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">{</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::Compound::Compound(const std::string&amp;)">Compound</a>(<a href="" title="typedef std::string">std::string const</a> &amp;name) : Type(name) {}</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">};</span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html" title="class Synopsis::TypeAnalysis::Class">Class</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Compound.html" title="class Synopsis::TypeAnalysis::Compound">Compound</a></span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">{</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">  <span class="keyword">enum</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html#Kind" title="enum Synopsis::TypeAnalysis::Class::Kind">Kind</a> { <a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html#STRUCT" title="enumerator Synopsis::TypeAnalysis::Class::STRUCT">STRUCT</a>, <a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html#CLASS" title="enumerator Synopsis::TypeAnalysis::Class::CLASS">CLASS</a>};</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::Class::Class(Kind,const std::string&amp;)">Class</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html#Kind" title="enum Synopsis::TypeAnalysis::Class::Kind">Kind</a> kind, <a href="" title="typedef std::string">std::string const</a> &amp;name) : Compound(name), my_kind(kind) {}</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Class::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line82"></a><span class="lineno"> 82</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html#Kind" title="enum Synopsis::TypeAnalysis::Class::Kind">Kind</a> <a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html#my_kind" title="data member Synopsis::TypeAnalysis::Class::my_kind">my_kind</a>;</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">};</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Union.html" title="class Synopsis::TypeAnalysis::Union">Union</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Compound.html" title="class Synopsis::TypeAnalysis::Compound">Compound</a></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">{</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::Union::Union(const std::string&amp;)">Union</a>(<a href="" title="typedef std::string">std::string const</a> &amp;name) : Compound(name) {}</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Union.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Union::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">};</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html" title="class Synopsis::TypeAnalysis::CVType">CVType</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">{</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  <span class="keyword">enum</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#CVQualifier" title="enum Synopsis::TypeAnalysis::CVType::CVQualifier">CVQualifier</a> { <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#NONE" title="enumerator Synopsis::TypeAnalysis::CVType::NONE">NONE</a>=0x0, <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#CONST" title="enumerator Synopsis::TypeAnalysis::CVType::CONST">CONST</a>=0x1, <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#VOLATILE" title="enumerator Synopsis::TypeAnalysis::CVType::VOLATILE">VOLATILE</a>=0x2};</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#CVType_lconst.Type_S_cCVQualifier_r" title="member function Synopsis::TypeAnalysis::CVType::CVType(const Type*,CVQualifier)">CVType</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *type, <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#CVQualifier" title="enum Synopsis::TypeAnalysis::CVType::CVQualifier">CVQualifier</a> q)</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">    : Type(names[q]), my_type(type), my_qual(q) {}</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::CVType::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">  static <a href="" title="typedef std::string">std::string const</a> <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#names" title="data member Synopsis::TypeAnalysis::CVType::names">names</a>[4];</span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#my_type" title="data member Synopsis::TypeAnalysis::CVType::my_type">my_type</a>;</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#CVQualifier" title="enum Synopsis::TypeAnalysis::CVType::CVQualifier">CVQualifier</a> <a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html#my_qual" title="data member Synopsis::TypeAnalysis::CVType::my_qual">my_qual</a>;</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">};</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Pointer.html" title="class Synopsis::TypeAnalysis::Pointer">Pointer</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line113"></a><span class="lineno">113</span><span class="line">{</span>
<a id="line114"></a><span class="lineno">114</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Pointer.html#Pointer_lconst.Type_S_r" title="member function Synopsis::TypeAnalysis::Pointer::Pointer(const Type*)">Pointer</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *type) : Type(&quot;*&quot;), my_type(type) {}</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Pointer.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Pointer::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/Pointer.html#my_type" title="data member Synopsis::TypeAnalysis::Pointer::my_type">my_type</a>;</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">};</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Reference.html" title="class Synopsis::TypeAnalysis::Reference">Reference</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line123"></a><span class="lineno">123</span><span class="line">{</span>
<a id="line124"></a><span class="lineno">124</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Reference.html#Reference_lconst.Type_S_r" title="member function Synopsis::TypeAnalysis::Reference::Reference(const Type*)">Reference</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *type) : Type(&quot;&amp;&quot;), my_type(type) {}</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Reference.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Reference::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/Reference.html#my_type" title="data member Synopsis::TypeAnalysis::Reference::my_type">my_type</a>;</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">};</span>
<a id="line131"></a><span class="lineno">131</span>
<a id="line132"></a><span class="lineno">132</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Array.html" title="class Synopsis::TypeAnalysis::Array">Array</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line133"></a><span class="lineno">133</span><span class="line">{</span>
<a id="line134"></a><span class="lineno">134</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Array.html#Array_lconst.Type_S_r" title="member function Synopsis::TypeAnalysis::Array::Array(const Type*)">Array</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *type) : Type(&quot;[]&quot;), my_type(type) {}</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Array.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Array::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line137"></a><span class="lineno">137</span>
<a id="line138"></a><span class="lineno">138</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/Array.html#my_type" title="data member Synopsis::TypeAnalysis::Array::my_type">my_type</a>;</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">};</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Function.html" title="class Synopsis::TypeAnalysis::Function">Function</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line143"></a><span class="lineno">143</span><span class="line">{</span>
<a id="line144"></a><span class="lineno">144</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Function.html#Function_l_r" title="member function Synopsis::TypeAnalysis::Function::Function()">Function</a>() : Type(&quot;&quot;) {}</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Function.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::Function::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/Function.html#my_type" title="data member Synopsis::TypeAnalysis::Function::my_type">my_type</a>;</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">};</span>
<a id="line151"></a><span class="lineno">151</span>
<a id="line152"></a><span class="lineno">152</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/PointerToMember.html" title="class Synopsis::TypeAnalysis::PointerToMember">PointerToMember</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a></span>
<a id="line153"></a><span class="lineno">153</span><span class="line">{</span>
<a id="line154"></a><span class="lineno">154</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/PointerToMember.html#PointerToMember_l_r" title="member function Synopsis::TypeAnalysis::PointerToMember::PointerToMember()">PointerToMember</a>() : Type(&quot;&quot;) {}</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/PointerToMember.html#accept_lVisitor_S_r" title="member function Synopsis::TypeAnalysis::PointerToMember::accept(Visitor*)">accept</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a> *visitor) { <a href="" title="parameter visitor">visitor</a>-&gt;<a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/PointerToMember.html#my_container" title="data member Synopsis::TypeAnalysis::PointerToMember::my_container">my_container</a>;</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/PointerToMember.html#my_member" title="data member Synopsis::TypeAnalysis::PointerToMember::my_member">my_member</a>;</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">};</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">}</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">}</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:03 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
